/**************************************************************************
 *  This file is part of QXmlEdit                                         *
 *  Copyright (C) 2011 by Luca Bellonda and individual contributors       *
 *    as indicated in the AUTHORS file                                    *
 *  lbellonda _at_ gmail.com                                              *
 *                                                                        *
 * This library is free software; you can redistribute it and/or          *
 * modify it under the terms of the GNU Library General Public            *
 * License as published by the Free Software Foundation; either           *
 * version 2 of the License, or (at your option) any later version.       *
 *                                                                        *
 * This library is distributed in the hope that it will be useful,        *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 * Library General Public License for more details.                       *
 *                                                                        *
 * You should have received a copy of the GNU Library General Public      *
 * License along with this library; if not, write to the                  *
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,       *
 * Boston, MA  02110-1301  USA                                            *
 **************************************************************************/

#include "xmlutils.h"
#include "xsdeditor/xschema.h"

XmlUtils::XmlUtils()
{
}

XmlUtils::~XmlUtils()
{
}


/**
  checks if the root element namespace and element correspond to thos if XSD
  */

bool XmlUtils::IsXsdValid(const QString &nsUri, const QString &localName)
{
    return XSDSchema::IsXsdValid(nsUri, localName);
}


QString XmlUtils::namespacePrefix(const QString &name)
{
    int indexOf = name.indexOf(":");
    if(indexOf >= 0) {
        return name.mid(indexOf + 1);
    }
    return "";
}

/**
 * @brief XmlUtils::stripNs
 *name without namespace, if any
 * @param name
 * @return
 */
QString XmlUtils::stripNs(const QString &name)
{
    int indexOf = name.indexOf(":");
    if(indexOf >= 0) {
        return name.mid(indexOf + 1);
    }
    return name;
}


bool XmlUtils::hasPrefix(const QString &tag, const QString &nsPrefix)
{
    bool result ;
    if(nsPrefix.isEmpty()) {
        result = !tag.contains(":");
    } else {
        result = tag.startsWith(nsPrefix + ":");
    }
    return result;
}
