#/**************************************************************************
# *  This file is part of QXmlEdit                                         *
# *  Copyright (C) 2011 by Luca Bellonda and individual contributors       *
# *    as indicated in the AUTHORS file                                    *
# *  lbellonda _at_ gmail.com                                              *
# *                                                                        *
# * This library is free software; you can redistribute it and/or          *
# * modify it under the terms of the GNU Library General Public            *
# * License as published by the Free Software Foundation; either           *
# * version 2 of the License, or (at your option) any later version.       *
# *                                                                        *
# * This library is distributed in the hope that it will be useful,        *
# * but WITHOUT ANY WARRANTY; without even the implied warranty of         *
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
# * Library General Public License for more details.                       *
# *                                                                        *
# * You should have received a copy of the GNU Library General Public      *
# * License along with this library; if not, write to the                  *
# * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,       *
# * Boston, MA  02110-1301  USA                                            *
# **************************************************************************/
#
# Project created by QtCreator 2011-08-15T09:23:52
#
#-------------------------------------------------


# This is necessary to build the test executable as an app
DEFINES += LIBQXMLEDIT_LIBRARY_STATIC
DEFINES += QXMLEDITSESSIONS_LIBRARY_STATIC
DEFINES += QXMLEDIT_NOMAIN
DEFINES += QXMLEDIT_TEST

QT       += gui xml xmlpatterns svg testlib network sql

greaterThan(QT_MAJOR_VERSION, 4) {
    QT       += printsupport widgets core
}

greaterThan(QT_MAJOR_VERSION, 4) {
win32 {
    DEFINES += "_NO_W32_PSEUDO_MODIFIERS"
    DEFINES += "NOGDI"
}
}

QMAKE_CXXFLAGS +=-Werror=format-security

TARGET = qxmledittest
CONFIG   += console
CONFIG   -= app_bundle

TEMPLATE = app
DESTDIR = ../build

SOURCES += \
    searchInFilesLogic.cpp \
    comparexml.cpp \
    tst_qxmledit.cpp \
    testcomment.cpp \
    testxsd.cpp \
    testpaste.cpp \
    testsplit.cpp \
    fakeuidelegate.cpp \
    testmixedcontent.cpp \
    testbase64.cpp \
    testeditingcommands.cpp \
    testexecution.cpp \
    testvalidation.cpp \
    app.cpp \
    testuifile.cpp \
    testsessions.cpp \
    testsqlaccess.cpp \
    sqlliteaccess.cpp \
    testeditelements.cpp \
    testundoredo.cpp \
    testvis.cpp \
    testdoctype.cpp \
    testxsddiff.cpp \
    exportcsvtest.cpp \
    testfilterattributes.cpp \
    testcomparexml.cpp \
    testbase.cpp \
    helpers/testcomparexmlunithelper.cpp \
    helpers/comparetreewithxml.cpp \
    testspringandforces.cpp \
    testsearch.cpp \
    testcopyattrs.cpp \
    testxsdnavigation.cpp \
    testclipboard.cpp \
    testnewfromtemplate.cpp \
    testxsltmode.cpp \
    testhelpers/xslnavigator.cpp \
    testhelpers/XSLTAutoModeDialogprivatetest.cpp \
    teststyle.cpp \
    testhelpers/XsltElementDialogprivatetest.cpp \
    helpers/comparetrees.cpp \
    testxsdcopy.cpp \
    testhelpers/testsnippethandler.cpp

DEFINES += SRCDIR=\\\"$$PWD/\\\"

# object files
OBJECTS_DIR = ../build/test/obj
MOC_DIR = ../build/test/moc
UI_DIR = ../build/test/ui
UI_HEADERS_DIR = ../build/test/ui/include
UI_SOURCES_DIR = ../build/test/ui/src
RCC_DIR = ../build/test/rcc

INCLUDEPATH += ../src

include(test.pri)

HEADERS += \
    comparexml.h \
    testcomment.h \
    testxsd.h \
    testpaste.h \
    testsplit.h \
    fakeuidelegate.h \
    testmixedcontent.h \
    testbase64.h \
    testeditingcommands.h \
    testexecution.h \
    testvalidation.h \
    app.h \
    testuifile.h \
    testsessions.h \
    testsqlaccess.h \
    sqlliteaccess.h \
    testeditelements.h \
    testundoredo.h \
    testvis.h \
    testdoctype.h \
    testxsddiff.h \
    exportcsvtest.h \
    testfilterattributes.h \
    testcomparexml.h \
    testbase.h \
    helpers/testcomparexmlunithelper.h \
    helpers/comparetreewithxml.h \
    testspringandforces.h \
    testsearch.h \
    testcopyattrs.h \
    testxsdnavigation.h \
    testclipboard.h \
    testnewfromtemplate.h \
    testxsltmode.h \
    testhelpers/xslnavigator.h \
    testhelpers/XSLTAutoModeDialogprivatetest.h \
    teststyle.h \
    testhelpers/XsltElementDialogprivatetest.h \
    helpers/comparetrees.h \
    testxsdcopy.h \
    testhelpers/testsnippethandler.h









